#property copyright "Copyright  2015, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int SLIPPAGE_IN_PIPS=6;
extern int Start_Hour=12;
extern int Start_Minute=15;
extern int Percent_from_Ballance=5;
extern double LOT_SIZE_IN_PERCENT=7;
extern bool WorkEveryDay=false;       //    .     
extern int TP=100;
extern int SL=400;
//--------------------------------------------------------
static double DestinationProfit, maxl, minl, hand_point, BALPREV;
static bool is_started, need_creation, HP, CHECKPOINT;
static datetime Last_DDT, IO[5], Last_DDT2;
static int liver, MLST, DIGITS_OF_LOT, Digits_now, BS[2], border, OPREV;
static string s2;
//--------------------------------------------------------
void init()
  {
  int fp, j, q;
  datetime DDT;
  double W;
  //--------------------------------------------------------------------------------
  s2=""; while (s2=="") s2=Symbol();
  minl=0; maxl=0; MLST=0; Digits_now=0; hand_point=0; border=0;
  while (MLST==0 || minl==0 || maxl==0 || Digits_now==0 || hand_point==0 || border==0)
        {
        minl=MarketInfo(s2, MODE_MINLOT);
        maxl=MarketInfo(s2, MODE_MAXLOT);
        MLST=MarketInfo(s2, MODE_LOTSTEP);
        Digits_now=MarketInfo(s2, MODE_DIGITS);
        hand_point=MarketInfo(s2, MODE_POINT);
        border=MarketInfo(s2, MODE_STOPLEVEL);
        }
  //----------------------------------------------
  liver=AccountLeverage();
  HP=false;
  ArrayInitialize(IO,0);
  ArrayInitialize(BS,0);
  need_creation=true;
  DestinationProfit=0;
  DDT=TimeLocal();
  Last_DDT2=0;
  Last_DDT=DDT+(24-TimeHour(DDT))*3600;
  j=500; fp=-1; while (fp==-1 && j>0) {fp=FileOpen("Alarm_FX.cfg",FILE_BIN|FILE_READ|FILE_WRITE); j--;}
  if (fp!=-1)
     {
     if (FileSize(fp)>0)
        {
        j=FileReadArray (fp, IO,0, 4);
        if (j>0)
           {
           Last_DDT=IO[0];
           DestinationProfit=IO[1];
           q=IO[2];
           HP=q;
           Last_DDT2=IO[3];
           need_creation=false;
           } 
        }
     FileClose(fp);
     }
  //-------------------------------------------------------
  W=MLST;
  for (j=0; j<6; j++) if (NormalizeDouble(W, j)==W) {DIGITS_OF_LOT=j; if (j!=5) break;}
  Last_DDT2=0;
  is_started=false;
  CHECKPOINT=false;
  OPREV=OrdersTotal();
  BALPREV=AccountBalance();
  return;
  }

void deinit(){return;}

void start()
  {
  bool Write=false, res_try;
  datetime DDT;
  int i, j, fp, t, lp, ot, cmd, try;
  double b, W, W_P, CW, zoom, LG, ask0, bid0, Lot_Size;
  string s3;
  //---------------------------------------------------------
if (IsConnected())
   {
  DDT=TimeLocal();
  b=AccountBalance();
  if (b>=DestinationProfit && DestinationProfit!=0)   //   ,       
     {
     Last_DDT=DDT+(24-TimeHour(DDT))*3600;
     Last_DDT2=DDT+120;
     HP=true;
     Write=true;
     is_started=false;
     CHECKPOINT=true;
     }
     else if (HP && DDT>=Last_DDT) CHECKPOINT=WorkEveryDay;
  //----------------------------------------------------------
  if (!is_started)
     {
     i=TimeHour(DDT); t=TimeMinute(DDT);
     if (Write || (i>=Start_Hour && t>=Start_Minute && (DDT<=Last_DDT && !HP) || (DDT>=Last_DDT && HP && CHECKPOINT)))
        {
        if (need_creation || Write)
           {
           j=500; fp=-1; while (fp==-1 && j>0) {fp=FileOpen("Alarm_FX.cfg",FILE_BIN|FILE_READ|FILE_WRITE); j--;}
           if (fp!=-1)
              {
              if (FileSize(fp)>0)
                 {
                 IO[0]=Last_DDT;
                 DestinationProfit=b+(b*Percent_from_Ballance/100);
                 IO[1]=NormalizeDouble(DestinationProfit,0);
                 j=HP;
                 IO[2]=j;
                 IO[3]=Last_DDT2;
                 j=FileWriteArray (fp, IO,0, 4);
                 need_creation=false;
                 }//if (FileSize(fp)>0)
              FileClose(fp);
              }//if (fp!=-1)
           }//if (need_creation || Write)
        is_started=!Write;
        }//if (i>=Start_Hour && t>=Start_Minute && DDT<Last_DDT)
     }//if (!is_started)
  //-------------------------------------------------------------------------------------------------------
  ot=OrdersTotal();              //  
  if (ot!=0)
     {
     if (DDT<Last_DDT2) Write=true;    //Last_DDT2 -     
     if (ot!=OPREV && !Write && b>BALPREV) is_started=true;   // -       -  %
     }
  //-------------------------------------------------------------------------------------------------------
  if (is_started || Write)    //    
     {
     if (Write && ot!=0)
        {
        for (i=0; i<ot; i++) if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) && OrderType()<2)
            {
            if (OrderCloseTime()==0)  //   
               {
               s3=OrderSymbol();
               cmd=OrderType();
               LG=OrderLots();
               lp=OrderTicket();
               try=100; res_try=false;    //   10- 
               while (!res_try && try>0)
                     {
                     if (cmd==0) CW=MarketInfo(s3, MODE_BID); else CW=MarketInfo(s3, MODE_ASK);
                     res_try=OrderClose(lp, LG, NormalizeDouble(CW,Digits_now), SLIPPAGE_IN_PIPS, NULL);
                     if (try!=100) Sleep(100);
                     try--;
                     }
               }//if (OrderCloseTime()==0)
            }//for
        }//if (Write && ot!=0)
     //----------------------------------------------------------------------------
     if (is_started)      //    2 
        {
        if (b<=5) W_P=minl; else
           {
           W=LOT_SIZE_IN_PERCENT;
           if (W<1) W=1; else if (W>100) W=100;
           if (liver>700) lp=700; else lp=liver;
           CW=1100-(lp+lp)-(lp/100)+150;
           W_P=(b*W/100)/CW;                      //   - !!!
           if (W_P<minl) W_P=minl; else if (W_P>maxl) W_P=maxl;
           W_P=NormalizeDouble(W_P, DIGITS_OF_LOT);
           }
        Lot_Size=W_P;
        //----------------------------------------------------------------------/*/*
        ask0=MarketInfo(s2, MODE_ASK);
        bid0=MarketInfo(s2, MODE_BID);
        lp=border; border=MarketInfo(s2, MODE_STOPLEVEL); if (border<1) border=lp;
        if (SL<border) i=border; else i=SL;
        if (TP<border) j=border; else j=TP;    //                          SL                 TP
        if (BS[0]==0) j=OrderSend(s2, 0, Lot_Size, ask0, SLIPPAGE_IN_PIPS, bid0-i*hand_point, ask0+j*hand_point, NULL, NULL, 0, NULL); else j=0;
        if (BS[1]==0) t=OrderSend(s2, 1, Lot_Size, bid0, SLIPPAGE_IN_PIPS, ask0+i*hand_point, bid0-j*hand_point, NULL, NULL, 0, NULL); else t=0;
        ArrayInitialize(BS,1);
        if (j==-1 || t==-1)
           {
           if (j==-1) BS[0]=0; else BS[1]=0;
           }
        if (j!=-1 && t!=-1) is_started=false;   //     ,    
        }//if (is_started)
     }//if (is_started || Write)
  //-----------------------------------------------------------------------------------------------------------
  OPREV=OrdersTotal();
  BALPREV=AccountBalance();
  }//if (IsConnected()) 
  return;
  }

